;;; package.lisp ---
;;
;; Copyright (C) 2010, 2011 Jan Moringen
;;
;; Author: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>
;;
;; This Program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This Program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses>.

(defpackage :gi
  (:use
   :cl
   :alexandria
   :iterate
   :s-xml
   :bind)

  ;;
  (:export
   :find-node)

  ;; node superclass
  (:export
   :node
   :node-name :node-foreign-name :node-doc :node-value)

  ;; composite mixin class
  (:export
   :composite
   :composite-children)

  ;; typed mixin class
  (:export
   :typed-mixin
   :node-type)

  ;; value mixin class
  (:export
   :value-mixin
   :node-value)

  ;; class mixin class
  (:export
   :class-mixin
   :class-type-name :class-type-getter :class-properties :class-fields)

  ;; repository, include and package classes
  (:export
   :repository :include :package1)

  ;; namespace class
  (:export
   :namespace
   :namespace-shared-library)

  ;; alias, constant, type, array, union and enumeration classes
  (:export
   :alias :constant :type1 :array1 :union1 :enumeration)

  ;; enumeration member class
  (:export
   :member1
   :value-nick)

  ;; interface class
  (:export
   :interface)

  ;; class class
  (:export
   :class1
   :class-parent :class-implemented-interfaces :class-abstract)

  ;; record, property, field and signal classes
  (:export
   :record :property :field :signal1)

  ;; function class
  (:export
   :function1
   :function-return-type :function-parameters
   :function-some-out-parameters?)

  ;; method, virtual-method and constructor classes
  (:export
   :method1 :virtual-method :constructor)

  ;; parameter class
  (:export
   :parameter
   :parameter-type :parameter-direction :parameter-out?))
